#ifndef	__MAIN_H__
#define __MAIN_H__

#ifndef	NULL
#ifdef _cplusplus
#define	NULL	0
#endif
#endif

#ifndef	MAX_PATH
#define	MAX_PATH	260
#endif

#ifndef	PI
#define	PI		3.14159265358979
#endif

#ifndef	HALF_PI
#define	HALF_PI		1.57079632679489
#endif


#include <lwserver.h>
#include <lwhost.h>
#include <lwcmdseq.h>
#include <lwmeshes.h>

#include <vector>
#include <string>
#include <stdio.h>

#define	SERVERNAME	"MirrorWeight"

typedef struct{
	int			active;
	std::string	src;
	std::string	dist;
	LWID		mapID;
}WeightListData;

typedef struct{
	int							operation;
	int							replace;
	std::string					srcKey;
	std::string					distKey;
	std::string					name;
}SettingData;

typedef struct {
	GlobalFunc					*global;
	MeshEditOp					*edit;
	std::vector<WeightListData>	wlist;
	std::vector<WeightListData>	allwlist;
	int							operation;
	int							replace;
	std::string					srcKey;
	std::string					distKey;
	int							mapType;
	std::vector<SettingData>	settings;
}MyData;

XCALL_(int)Activate(long version, GlobalFunc *global, LWModCommand *local, void *serverData);
int Panel(MyData *data, GlobalFunc *global);
void listupEditWMap(MyData *data);
void listupAllWMap(MyData *data);


#endif  //__MAIN_H__


