/*

PanelServices

wb_[		lwpanel.h

*/

#include "main.h"
#include <lwpanel.h>

static LWPanControlDesc		desc;	 // required by macros in lwpanel.h
static LWValue				ival={LWT_INTEGER};
static LWValue				ivecval={LWT_VINT};		// required by macros in lwpanel.h
static LWValue				fval={LWT_FLOAT};
static LWValue				fvecval={LWT_VFLOAT};
static LWValue				sval={LWT_STRING};


/*
pli
------------------------
@Rs[(X)@[|{][|{]
@uʒu@[ړ][ڔ]
@}bvړ()@[Left]         
@Ώۃ}bvړ()@[Right]
@[XV{^]
@[@}bv@|@Ώۃ}bv@]
------------------------
ERs[F@EǂɃRs[̂H(Q)@
EuʒuF@ړ()񂪑OƌǂɂĂ̂H(Q)
Eړ()F@Ώۃ}bv̂߂邽߂Ɏg
@Left_ArmRight_Armɂꍇ́ALeftAΏۂRight
E}bvF@ɂȂEGCg}bv
EΏۃ}bvF@}bv̍EΏ̂̃EGCg}bv(Rs[̑Ώ)
@Ώۃ}bv̂͌}bv̖̂̐ړ()ûɂȂ

)Left_ArmRight_Arm@ړuŁAړ()LeftRight̏ꍇ
*/


static void btnEvent(LWControl *ctl, void *eventData);
static void listEvent(LWControl *ctl, void *eventData);
static void operationEvent(LWControl *ctl, void *eventData);
static void replaceEvent(LWControl *ctl, void *eventData);
static void vmapTypeEvent(LWControl *ctl, void *eventData);
static int countfunc(void *eventData);
static char * namefunc(void *eventData, int n, int m);
static int widthfunc(void *eventData, int n);
static int settingPopCount(void *eventData);
static char * settingPopName(void *eventData, int n);
static void settingPopEvent(LWControl *ctl, void *eventData);

LWControl	*g_mlistctl = NULL;
LWControl	*g_srckey = NULL;
LWControl	*g_distkey = NULL;
LWControl	*g_operation = NULL;
LWControl	*g_replace = NULL;

LWPanelFuncs *g_panel = NULL;

/*
void checkCtlPos(LWControl **ctl, int num)
{
	FILE	*fp;
	int		x, y, w, h, i;

	fp = fopen("C:\\#GUI_Check.txt", "wt");
	if( fp ){
		for(i=0; i<num; i++){
			x = CON_X(ctl[i]);
			y = CON_Y(ctl[i]);
			w = CON_W(ctl[i]);
			h = CON_H(ctl[i]);
			fprintf(fp, "%03d: (%04d, %04d) W:%04d H:%04d\n", i, x, y, w, h);
		}
		fclose(fp);
	}
}
//*/

//pl\֐
int Panel(MyData *data, GlobalFunc *global)
{
	LWPanelFuncs	*panel = (LWPanelFuncs*)global(LWPANELFUNCS_GLOBAL, GFUSE_TRANSIENT);
	LWPanelID		pid = NULL;
	int				result = 0;
	LWControl		*ctl[8];
	const char		*operation[] = {"|  {", "|  {", NULL};
	const char		*replace[] = {"ړ", "ڔ", NULL};
	char			buffer[MAX_PATH];
	const char		*vmapTypes[] = {"EFCg", "[t", "X|bg", NULL};

	if( !panel )
		return result;
	g_panel = panel;

	if( pid = PAN_CREATE(panel, SERVERNAME) ){
		ctl[0] = HCHOICE_CTL(panel, pid, "Rs[(X)", operation);
		ctl[1] = HCHOICE_CTL(panel, pid, "uʒu", replace);
		ctl[2] = STR_CTL(panel, pid, "}bv", 32);
		ctl[3] = STR_CTL(panel, pid, "Ώۃ}bv", 32);
		ctl[4] = BUTTON_CTL(panel, pid, "XV");
		ctl[5] = MULTILIST_CTL(panel, pid, "uꗗ", 450, 8, namefunc, countfunc, widthfunc);
		ctl[6] = WPOPUP_CTL(panel, pid, "_}bv^Cv", vmapTypes, 75);
		ctl[7] = CUSTPOPUP_CTL(panel, pid, "vZbg", 150, settingPopName, settingPopCount);

		if( -1 == data->operation ) data->operation = 0;
		SET_INT(ctl[0], data->operation);
		SET_INT(ctl[1], data->replace);
		strcpy(buffer, data->srcKey.c_str());
		SET_STR(ctl[2], buffer, strlen(buffer));
		strcpy(buffer, data->distKey.c_str());
		SET_STR(ctl[3], buffer, strlen(buffer));
		SET_INT(ctl[6], data->mapType);

		ival.intv.value = (int)data;
		ctl[5]->set(ctl[5], CTL_USERDATA, &ival);
		CON_SETEVENT(ctl[5], (int)listEvent, (int)data);
		CON_SETEVENT(ctl[4], (int)btnEvent, (int)data);
		CON_SETEVENT(ctl[0], (int)operationEvent, (int)data);
		CON_SETEVENT(ctl[1], (int)replaceEvent, (int)data);
		CON_SETEVENT(ctl[6], (int)vmapTypeEvent, (int)data);
		CON_SETEVENT(ctl[7], (int)settingPopEvent, (int)data);

		g_mlistctl = ctl[5];
		g_srckey = ctl[2];
		g_distkey = ctl[3];
		g_operation = ctl[0];
		g_replace = ctl[1];

		/*
		checkCtlPos(ctl, 6);
		//*/
		MOVE_CON(ctl[6], 4,		2 + 25 * 0	);
		MOVE_CON(ctl[7], 220,	2 + 25 * 0	);
		MOVE_CON(ctl[0], 4,		2 + 25 * 1	);
		MOVE_CON(ctl[1], 220,	2 + 25 * 1	);
		MOVE_CON(ctl[2], 4,		2 + 25 * 2	);
		MOVE_CON(ctl[3], 240,	2 + 25 * 2	);
		MOVE_CON(ctl[4], 4,		2 + 25 * 3	);
		MOVE_CON(ctl[5], 4,		2 + 25 * 4	);

		if( PAN_POST(panel, pid) ){
			result = 1;
			GET_INT(ctl[0], data->operation);
			if( 0 == data->operation ) data->operation = -1;
			GET_INT(ctl[1], data->replace);
			GET_STR(ctl[2], buffer, MAX_PATH);
			data->srcKey = buffer;
			GET_STR(ctl[3], buffer, MAX_PATH);
			data->distKey = buffer;
			GET_INT(ctl[6], data->mapType);
		}
		PAN_KILL(panel, pid);
	}

	return result;
}


//XV{^ꂽƂɌĂ΂R[obN֐
static void btnEvent(LWControl *ctl, void *eventData)
{
	MyData	*data = (MyData*)eventData;
	char	buffer[MAX_PATH];

	GET_STR(g_srckey, buffer, MAX_PATH);
	data->srcKey = buffer;
	GET_STR(g_distkey, buffer, MAX_PATH);
	data->distKey = buffer;

	listupAllWMap(data);
	listupEditWMap(data);
	REDRAW_CON(g_mlistctl);
}

//XgRg[NbNꂽƂĂ΂
static void listEvent(LWControl *ctl, void *eventData)
{
	MyData	*data = (MyData*)eventData;
	int		x, y;

	x = CON_HOTX(ctl);
	if( 30 < x ) return;

	GET_INT(ctl, y);
	if( y >= data->wlist.size() ) return;

	//data->wlist[y].active ^= data->wlist[y].active;
	if( data->wlist[y].active ){
		data->wlist[y].active = 0;
	}else{
		data->wlist[y].active = 1;
	}
	REDRAW_CON(ctl);
}

static void operationEvent(LWControl *ctl, void *eventData)
{
	MyData	*data = (MyData*)eventData;
	GET_INT(ctl, data->operation);
}

static void replaceEvent(LWControl *ctl, void *eventData)
{
	MyData	*data = (MyData*)eventData;
	GET_INT(ctl, data->replace);
}

static void vmapTypeEvent(LWControl *ctl, void *eventData)
{
	MyData	*data = (MyData*)eventData;
	GET_INT(ctl, data->mapType);
}



//XgRg[@ACeԂ֐
static int countfunc(void *eventData)
{
	MyData	*data = (MyData*)eventData;
	if( !data ) return 0;

	return data->wlist.size();
}

//XgRg[@w肳ꂽ}X̕Ԃ
static char * namefunc(void *eventData, int n, int m)
{
	MyData		*data = (MyData*)eventData;
	const char	*column[] = {" ", "source", "dist"};
	if( !data ) return NULL;

	if( -1 == n ){
		if( 3 > m ){
			return (char*)column[m];
		}else{
			return NULL;
		}
	}
	if( n < data->wlist.size() ){
		if( 0 == m ){
			if( data->wlist[n].active ){
				return "v";
			}else{
				return " ";
			}
		}else if( 1 == m ){
			return (char*)data->wlist[n].src.c_str();
		}else if( 2 == m ){
			return (char*)data->wlist[n].dist.c_str();
		}else{
			return NULL;
		}
	}

	return NULL;
}

//XgRg[@}X̉Ԃ
static int widthfunc(void *eventData, int n)
{
	MyData	*data = (MyData*)eventData;
	int		width[] = { 30, 210, 210 };

	if( !data ) return 0;

	return width[n];
}

//
static int settingPopCount(void *eventData)
{
	MyData	*data = (MyData*)eventData;
	if( !data ) return 0;

	return (data->settings.size() + 1);
}

static char	* settingPopName(void *eventData, int n)
{
	MyData	*data = (MyData*)eventData;
	if( !data ) return NULL;

	int size = data->settings.size();
	if( n > size ) return NULL;
	else if( n == size ) return " ( new ) ";
	else return (char*)data->settings[n].name.c_str();
}

bool openNewSettingPanel(MyData *data)
{
	LWPanelFuncs		*panel = g_panel;
	LWPanelID			pid = NULL;
	char				buf[MAX_PATH];
	LWControl			*ctl;
	SettingData			setting;
	bool				result = false;

	if( pid = PAN_CREATE(panel, "vZbg쐬") ){
		ctl = STR_CTL(panel, pid, "vZbg", 64);
		if( PAN_POST(panel, pid) ){
			GET_INT(g_operation, setting.operation);
			GET_INT(g_replace, setting.replace);
			GET_STR(ctl, buf, MAX_PATH);
			setting.name = buf;
			GET_STR(g_srckey, buf, MAX_PATH);
			setting.srcKey = buf;
			GET_STR(g_distkey, buf, MAX_PATH);
			setting.distKey = buf;
			data->settings.push_back(setting);
			result = true;
		}
		PAN_KILL(panel, pid);
	}
	return result;
}

static void settingPopEvent(LWControl *ctl, void *eventData)
{
	MyData	*data = (MyData*)eventData;
	if( !data ) return;

	std::vector<SettingData>::iterator	itr;
	int popIndex, i;
	GET_INT(ctl, popIndex);

	if( popIndex == data->settings.size() ){
		if( openNewSettingPanel(data) ){
			REDRAW_CON(ctl);
		}
	}else{
		itr = data->settings.begin() + popIndex;
		i = itr->operation;
		SET_INT(g_operation, i);
		i = itr->replace;
		SET_INT(g_replace, i);
		SET_STR(g_srckey, (char*)itr->srcKey.c_str(), itr->srcKey.length());
		SET_STR(g_distkey, (char*)itr->distKey.c_str(), itr->distKey.length());
	}
}

